unit verhoeff;
interface

uses
  SysUtils ;

var
 d: array[0..9] of array [0..9] of byte =
   ((0, 1, 2, 3, 4, 5, 6, 7, 8, 9),
		(1, 2, 3, 4, 0, 6, 7, 8, 9, 5),
		(2, 3, 4, 0, 1, 7, 8, 9, 5, 6),
		(3, 4, 0, 1, 2, 8, 9, 5, 6, 7),
		(4, 0, 1, 2, 3, 9, 5, 6, 7, 8),
		(5, 9, 8, 7, 6, 0, 4, 3, 2, 1),
		(6, 5, 9, 8, 7, 1, 0, 4, 3, 2),
		(7, 6, 5, 9, 8, 2, 1, 0, 4, 3),
		(8, 7, 6, 5, 9, 3, 2, 1, 0, 4),
		(9, 8, 7, 6, 5, 4, 3, 2, 1, 0));

p: array[0..7] of array [0..9] of byte =
		((0, 1, 2, 3, 4, 5, 6, 7, 8, 9),
		 (1, 5, 7, 6, 2, 8, 3, 0, 9, 4),
		 (5, 8, 0, 3, 7, 9, 6, 1, 4, 2),
		 (8, 9, 1, 6, 0, 4, 3, 5, 2, 7),
		 (9, 4, 5, 3, 1, 2, 6, 8, 7, 0),
		 (4, 2, 8, 6, 5, 7, 3, 9, 0, 1),
		 (2, 7, 9, 3, 8, 0, 6, 4, 1, 5),
		 (7, 0, 4, 6, 9, 1, 3, 2, 5, 8));

inv: array[0..9] of byte =
		(0, 4, 3, 2, 1, 5, 6, 7, 8, 9);

function verhoeffCheck(number: String): boolean;
function verhoeffCheckDigit(number: String): integer;
function verhoeffCheckCompute(number: String): integer;

implementation


function verhoeffCheck(number: String): boolean;
var
	c, digit, i, len: Integer;
begin
   result := false;

   c := 0;
   number:=Trim(number) ;
   len := length(Trim(number));

    for i:=len  downto  1  do
	  begin
       digit := StrToInt(number[i]);
       c := d[c][p[(len-i ) mod 8][digit]];
    end;

	  if c = 0 then		result := true;
    
end;

function verhoeffCheckDigit(number: String): integer;
var
	c, digit, i, len: Integer;
begin

   c := 0;
   number:=Trim(number) ;
   len := length(Trim(number));

    for i:=len  downto  1  do
	  begin
       digit := StrToInt(number[i]);
       c := d[c][p[(len - i+1 ) mod 8][digit]];
    end;

	  result := inv[c];

end;

function verhoeffCheckCompute(number: String): integer;
var
	c, digit, i, len: Integer;
begin

   c := 0;
   number:=Trim(number) ;
   len := length(Trim(number));

    for i:=len  downto  1  do
	  begin

       digit := StrToInt(number[i]);
       c := d[c][p[(len - i+1 ) mod 8][digit]];

    end;

	 result :=StrToInt(number+inttostr(inv[c])) ;

end;


end.

